package WebFlow.tao_window;

import java.sql.*;
import java.io.*;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;

public class taoImpl extends WebFlow.BeanContextChildSupport implements tao_jdbcOperations{

  private Connection conn;//for connection with JDBC
  String msg_;
  PropertyChangeSupport pcs ;
  VetoableChangeSupport vcs ;
  org.omg.CORBA.Object peer;


  public taoImpl( org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  pcs = new PropertyChangeSupport(peer, this);
  vcs = new VetoableChangeSupport(peer, this);
  this.peer = peer;
  String msg_ = msg;
  }


  public void makeRecord( Data_Storage temp_storage ){
    try{
    Class.forName("oracle.jdbc.driver.OracleDriver");//get drive.
    //get connection with JDBC
    conn = DriverManager.getConnection("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe" , "gangwei", "gangwei");
        String s_context = "insert into tao_table " + "( year, month, day, hours, minutes, job )" + "values ( ?, ?, ?, ?, ?, ? )";
        PreparedStatement pstmt_context = conn.prepareStatement( s_context);
        pstmt_context.setString( 1, temp_storage.year );
        pstmt_context.setString( 2, temp_storage.month );
        pstmt_context.setString( 3, temp_storage.day );
        pstmt_context.setString( 4, temp_storage.hours );
        pstmt_context.setString( 5, temp_storage.minutes );
        pstmt_context.setString( 6, temp_storage.job );
        int r = pstmt_context.executeUpdate( s_context );
        pstmt_context.close();
         conn.close();

        System.out.println( "Inserting is successful." );
    }
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
  }//method

  public void deleteRecord( Data_Storage temp_storage ) {
    try{
    Class.forName("oracle.jdbc.driver.OracleDriver");//get drive.
    //get connection with JDBC
    conn = DriverManager.getConnection("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe" , "gangwei", "gangwei");
        String s_context = "delete from tao_table " + "where job = ?";
        PreparedStatement pstmt_context = conn.prepareStatement( s_context);
        pstmt_context.setString( 1, temp_storage.job );
        int r = pstmt_context.executeUpdate( s_context );
        pstmt_context.close();
         conn.close();

        System.out.println( "Inserting is successful." );
    }
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
  }//method

  public Data_Storage[] findRecord( Data_Storage temp_storage ){
    java.util.Vector vector = new java.util.Vector();
    try{
    Class.forName("oracle.jdbc.driver.OracleDriver");//get drive.
    //get connection with JDBC
    conn = DriverManager.getConnection("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe" , "gangwei", "gangwei");
	if( !( temp_storage.job.equals( "null" )) ){
		String s_context = "select * from tao_table " + "where job = ?";
        PreparedStatement pstmt_context = conn.prepareStatement( s_context );
        pstmt_context.setString( 1, temp_storage.job );
        ResultSet rs_context = null;
       rs_context = pstmt_context.executeQuery( );

        while( rs_context.next() ){
			Data_Storage temp = new Data_Storage( "null", "null", "null", "null", "null", "null");
			temp.job = temp_storage.job;
			temp.year =  rs_context.getString( 1 );
			temp.month =  rs_context.getString( 2 );
			temp.day =  rs_context.getString( 3 );
			temp.hours =  rs_context.getString( 4 );
			temp.minutes =  rs_context.getString( 5 );
            vector.addElement( temp );
            }
         pstmt_context.close();
	}//if
	else {
        String s_context = "select * from tao_table " + "where year = ? and month = ? and day = ?";
        PreparedStatement pstmt_context = conn.prepareStatement( s_context);
        pstmt_context.setString( 1, temp_storage.year );
        pstmt_context.setString( 2, temp_storage.month );
        pstmt_context.setString( 3, temp_storage.day );
        ResultSet rs_context = null;
       rs_context = pstmt_context.executeQuery( );

        while( rs_context.next() ){
            Data_Storage temp = new Data_Storage( "null", "null", "null", "null", "null", "null");
            temp.year =  rs_context.getString( 1 );
            temp.month =  rs_context.getString( 2 );
            temp.day =  rs_context.getString( 3 );
            temp.hours =  rs_context.getString( 4 );
            temp.minutes =  rs_context.getString( 5 );
            temp.job = rs_context.getString( 6 );
            vector.addElement( temp );
            }
        pstmt_context.close();
    }//else
    conn.close();
    }
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
    Data_Storage objectArray[] = new Data_Storage[ vector.size() ];
    for( int j = 0; j < vector.size(); j++ )
        objectArray[ j ] = ( Data_Storage ) vector.elementAt( j );

    return objectArray;

  }//method
}


